// vjb30050.cpp : AvP[VpNX̒`s܂B
//

#include "stdafx.h"
#include "vjb30050.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define DEVICE_FPD		"FPD"
#define DEVICE_MOD		"MOD"
#define DEVICE_CMT		"CMT"
#define DEVICE_DAT		"DAT"

/////////////////////////////////////////////////////////////////////////////
// CVjb30050App

BEGIN_MESSAGE_MAP(CVjb30050App, CWinApp)
	//{{AFX_MSG_MAP(CVjb30050App)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
		//        ̈ʒuɐR[hҏWȂłB
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVjb30050App NX̍\z

CVjb30050App::CVjb30050App()
{
	// TODO: ̈ʒuɍ\zp̃R[hǉĂB
	//  InitInstance ̏dvȏׂċLqĂB
}

/////////////////////////////////////////////////////////////////////////////
// B CVjb30050App IuWFNg

CVjb30050App theApp;

CString g_sLogDir;
CString g_sInputDir;
CString g_sDatDir;
CString g_sBatchUNC;

/////////////////////////////////////////////////////////////////////////////
// CVjb30050App NX̏

//
//	@\	F	CX^XJn
//
//		F	
//
//	Al	F	FALSE - vOI
//
//	@\F	vO{̂̏B
//
//	l	F	vOJnɃt[[NĂ΂B
//
BOOL CVjb30050App::InitInstance()
{
	m_nRetCode = Main(__argc, __argv);

	return FALSE;
}

//
//	@\	F	t@CRs[C
//
//		F	argc - p[^
//				argv - p[^e
//
//	Al	F	vOIR[h
//
//	@\F	t@CRs[vÕCsB
//
//	l	F	vOIɃt[[NĂ΂B
//
int CVjb30050App::Main(int argc, char *argv[])
{
	Param param;
	CString sSrcDir;
	CString sDstDir;
	char *pStatus;

	// p[^`FbN
	if (argc != 5)
		return RC_PARAMETER;

	// ep[^擾
	param.sShubetsuCode = argv[1];
	param.sBatchServer = argv[2];
	param.sShikibetsuCode = argv[3];
	param.sVolLabel = argv[4];

	// init@Cǂݍ
	ReadIniFile();

	// Rs[pX쐬
	if (param.sShubetsuCode == DEVICE_DAT)
		sSrcDir = g_sDatDir;
	else
		sSrcDir = CreatePathName(g_sInputDir, param.sShikibetsuCode + param.sVolLabel);

	// ob`T[õRs[pX(UNC)쐬
	sDstDir = CreatePathName("\\\\" + param.sBatchServer + "\\" + g_sBatchUNC, param.sShikibetsuCode + param.sVolLabel);

	// JnO
	WriteLogFile(&param, CreatePathName(g_sLogDir, "filecopystart"), NULL);

	// ob`T[õRs[fBNg폜
	DeleteDirectory(sDstDir, FALSE);

	// ob`T[õRs[fBNg쐬
	CreateDirectory(sDstDir, NULL);

	// ob`T[oɃt@CRs[
	if (CopyDirectory(sSrcDir, sDstDir, NULL)) {
		DispMessage(IDS_MSG_NORMAL_END, MB_OK, TRUE, param.sShubetsuCode);
		pStatus = "0";
	} else {
		DispMessage(IDS_MSG_COPY_ERROR, MB_OK, TRUE, param.sShubetsuCode, param.sBatchServer);
		pStatus = "7";
	}

	// Rs[fBNg̍폜
	DeleteDirectory(sSrcDir, param.sShubetsuCode != DEVICE_DAT);

	// IO
	WriteLogFile(&param, CreatePathName(g_sLogDir, "filecopyend"), pStatus);

	return 0;
}

//
//	@\	F	init@Cǂݍݏ
//
//		F	
//
//	Al	F	
//
//	@\F	init@CKvȏǂݍށB
//
//	l	F	
//
void CVjb30050App::ReadIniFile()
{
	// Ot@CfBNg擾
	g_sLogDir = GetIniData("LogFile", "Dir", "");

	// ̓fBNg擾
	g_sInputDir = GetIniData("InputFile", "InputDir", "dummy");

	// DATp̓fBNg擾
	g_sDatDir = GetIniData("InputFile", "DatDir", "dummy");

	// ob`T[oUNC擾
	g_sBatchUNC = GetIniData("BatchServer", "UNC", "");
}

//
//	@\	F	Ot@Cݏ
//
//		F	pParam - ̓p[^
//				pLogFile - Ot@C
//
//	Al	F	
//
//	@\F	w肳ꂽOt@CɃOށB
//
//	l	F	
//
void CVjb30050App::WriteLogFile(Param *pParam, LPCTSTR pLogFile, LPCTSTR pStatus)
{
	CStdioFile file;

	// Ot@CI[v
	if (file.Open(pLogFile, CFile::modeCreate | CFile::modeNoTruncate | CFile::modeWrite | CFile::shareDenyWrite)) {
		SYSTEMTIME st;
		CString str;

		// ݎ擾
		GetLocalTime(&st);

		// ÕtH[}bg
		str.Format("%04d/%02d/%02d %02d:%02d:%02d,%s,%s,%s,%s%s\n",
				st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond,
				pParam->sShubetsuCode,
				pParam->sBatchServer,
				pParam->sShikibetsuCode,
				pParam->sVolLabel,
				pStatus == NULL ? "" : (CString)"," + pStatus);

		// ŏIʒuɒǉ
		file.Seek(0, CFile::end);
		file.WriteString(str);
		file.Close();
	}
}
